=== modified file 'drizzled/db.cc'
--- drizzled/db.cc	2010-03-02 19:05:02 +0000
+++ drizzled/db.cc	2010-03-02 19:10:25 +0000
@@ -605,10 +605,17 @@
 
 bool mysql_change_db(Session *session, const std::string &new_db_name)
 {
-  LEX_STRING new_db_file_name;
 
   assert(not new_db_name.empty());
 
+  if (not plugin::Authorization::isAuthorized(session->getSecurityContext(),
+                                              new_db_name))
+  {
+    /* Error message is set in isAuthorized */
+    return true;
+  }
+
+
   /*
     Now we need to make a copy because check_db_name requires a
     non-constant argument. Actually, it takes database file name.
@@ -616,6 +623,7 @@
     TODO: fix check_db_name().
   */
 
+  LEX_STRING new_db_file_name;
   new_db_file_name.length= new_db_name.length();
   new_db_file_name.str= (char *)malloc(new_db_name.length() + 1);
   if (new_db_file_name.str == NULL)

